// Written by TeTeT
// Based on code from Ampersand

player addAction [
	"Start Flight Ops",
	"Nimitz setVariable ['ttt_amp_doFlightOps', true]; [Nimitz] call ttt_amp_kf_fnc_flightOps;",
	nil,
	1,
	false,
	false,
	"",
	"not (Nimitz getVariable ['ttt_amp_kf_flightOps', false])"
];

player addAction [
	"Stop Flight Ops",
	"Nimitz setVariable ['ttt_amp_doFlightOps', false]",
	nil,
	1,
	false,
	false,
	"",
	"Nimitz getVariable ['ttt_amp_kf_flightOps', true]"
];

[Nimitz] spawn {
	params ["_carrier"];
	sleep 1;
	_carrier setVariable ["ttt_amp_doFlightOps", true];
	[_carrier, "ttt_nimitz_planeLaunched", ttt_amp_kf_fnc_flyAway] call BIS_fnc_addScriptedEventHandler;
	[_carrier, "ttt_nimitz_planeReadyForOp", ttt_amp_kf_fnc_delete] call BIS_fnc_addScriptedEventHandler;
	[_carrier] call ttt_amp_kf_fnc_flightOps;
};

ttt_amp_kf_fnc_flightOps = {
	params ["_carrier", ["_planeClass", "JS_JC_FA18E"]];
	_carrier setVariable ["ttt_amp_kf_flightOps", true];
	if (alive player and alive _carrier and _carrier getVariable ["ttt_amp_doFlightOps", false]) then {
		private _elevator = selectRandom ["E1", "E2", "E3", "E4"];

		private _catapult = "C3";

		if (_elevator in ["E1", "E2"]) then {
			_catapult = selectRandom ["C1", "C2"];
		};

		systemChat format ["Starting from Elevator %1 and taking off from Catapult %2", _elevator, _catapult];
		private _spawnPos = [_carrier, _elevator] call ttt_amp_kf_fnc_getMempointNimitz;
		private _plane = createVehicle [_planeClass, _spawnPos, [], 0, "NONE"];
		_plane setVariable ["ttt_amp_kf_flightOpsPlane", true];
		_plane setPosASL [getPosASL _plane # 0, getPosASL _plane # 1, (getPosASL _carrier # 2) + 18];
		_plane setDir (getDir _carrier - 90);
		if (_elevator == "E4") then {
			_plane setDir (getDir _carrier + 90);
		};

		[_carrier, _plane, _catapult, true] call ttt_amp_kf_fnc_eleToTakeOff;
	} else {
		_carrier setVariable ["ttt_amp_kf_flightOps", false];
	};
};

ttt_amp_kf_fnc_eleToTakeOff = {
	// params ["_carrier", "_plane", "_catapult", "_elevator"];
	params ["_carrier", "_plane", "_catapult", "_delete"];

	_plane setVariable ["ttt_amp_kf_deleteAfterFlyAway", _delete];
	sleep 1;
	createVehicleCrew _plane;
	private _d = driver _plane;
	_d setPos [0,0,0];
	[_plane, 0] call ttt_amp_kf_fnc_f18_wingfold;
	private _timeline = [_carrier, _plane, _catapult] call ttt_amp_kf_fnc_taxi;
	_timeline setVariable ["ttt_amp_kf_takeoffPlane", _plane];
	_timeline setVariable ["EventFinished", "[(_this # 0) getVariable 'ttt_amp_kf_takeoffPlane'] call ttt_fnc_startLaunch"];
	_d assignAsDriver _plane;
	_d moveInDriver _plane;

	_plane;
};

ttt_amp_kf_fnc_flyAway = {
	params ["_catName", "_plane", "_nimspots"];

	if (not isPlayer driver _plane and _plane getVariable ["ttt_amp_kf_flightOpsPlane", false]) then {

		private _height = 1000 + random(1000);
		_plane flyInHeight _height;
		_plane flyInHeightASL [_height, _height, _height];
		private _wpPos = _nimspots getPos [-6000, random 360];
		_wpPos set [2, _height];
		(group driver _plane) addWaypoint [_wpPos, -50];
		waitUntil { sleep 0.1; _plane distance _wpPos < 500 };
		[_nimspots getVariable "ttt_nimitzParent"] call ttt_amp_kf_fnc_flightOps;
		[_nimspots getVariable "ttt_nimitzParent", "ttt_nimitz_planeReadyForOp", [_plane, _nimspots], false] call BIS_fnc_callScriptedEventHandler;
	};
	_plane;
};


ttt_amp_kf_fnc_delete = {
	params ["_plane", "_nimspots"];

	private _ret = _plane;
	if (not isPlayer driver _plane and _plane getVariable ["ttt_amp_kf_deleteAfterFlyAway", true]
		and _plane getVariable ["ttt_amp_kf_flightOpsPlane", false]) then {
		systemChat "Despawning plane";
		deleteVehicleCrew _plane;
		deleteVehicle _plane;
		_ret = objNull;
	};
	_ret;
};

	/**
	 * Does not work reliably
	systemChat "Initiating landing";
	private _spd = speed _plane;
	_plane setDir (getDir _carrier + 10);
	_plane setVelocityModelSpace [0, _spd / 3.6, 0];
	_plane landAt (_carrier getVariable "JDG_dynamicAirportNimitz");
	waitUntil { sleep 0.1; speed _plane < 1 };
	_plane animateSource ["tailhook", 0];
	[_plane, 1] call ttt_amp_kf_fnc_f18_wingfold;
	// need to delete the crew, otherwise the kf will play on the crew, not the vehicle
	_d setPos [0,0,0];
	[_carrier, _plane, _elevator] call ttt_amp_kf_fnc_taxi;
	_d assignAsDriver _plane;
	_d moveInDriver _plane;
	private _elevator = [_carrier, _elevator] call ttt_amp_kf_fnc_getMempointNimitz;
	waitUntil {_elevator distance2D _plane < 0.1};
	_plane engineOn false;
	**/


ttt_amp_kf_fnc_f18_wingfold = {
	params ["_f18", "_status"];

	_f18 animate ["l_wingfold", _status];
	_f18 animate ["r_wingfold", _status];
	_f18;
};

ttt_amp_kf_fnc_getMempointNimitz = {
	params ["_carrier", "_memPoint"];

	private _nimspots = _carrier getVariable ["nimspots", objNull];
	private _ret = ["undefined"];
	if (isNull _nimspots) then {
		"nimspots not defined" call bis_fnc_error;
	} else {
		_ret = _nimspots modelToWorldVisualWorld (_nimspots selectionPosition _memPoint);
	};
	_ret;
};

ttt_amp_kf_fnc_taxi = {
	params ["_carrier", "_plane", "_taxiPoint"];
	// _plane allowDamage false;

	// capture/calculate keys start

	private _cat = [_carrier, _taxiPoint] call ttt_amp_kf_fnc_getMempointNimitz;
	_cat set [2, getPosASL _plane # 2];

	private _keysData = [
		[
			0,
			getPosASL _plane,
			[
				vectorDir _plane,
				[0, 0, 1] // Just up unless pitch/roll
			],
			[
				["LeaveTangent", vectorDir _plane],
				["LeaveTangentWeight", 100],
	    		["InterpMode", 1]
			]
		],
		[
			1,
			_cat,
			[
				vectorDir _carrier,
				[0, 0, 1]
			],
			[
				["ArriveTangent", (vectorDir _carrier) vectorMultiply -1],
				["ArriveTangentWeight", 100],
	    		["InterpMode", 1]
			]
		]
	];

	private _timelineData     = [ // Timeline variables
	    ["Length", 20],
	    ["Loop", false],
	    ["InterpMode", 1]
	];
	private _curvesData = [
	    [ // curve1
	        [_plane], // vehicles
	        [ // Curve variables
	            ["OrientationMode", 3],
	            ["TimeInSeconds", false]
	        ],
	        _keysData
	    ]
	];

	[_timelineData, _curvesData] call compile preprocessFileLineNumbers "keyframe.sqf";
};